package meshi.util.crossLinking;

import meshi.molecularElements.Protein;

abstract class Peptidase {

	Peptidase() {}

	boolean isCterm(Protein prot, int residueNumber) {
		if (prot.residue(residueNumber+1) == null) // End of the chain
			return true;
		return prot.residue(residueNumber + 1).ca() == null;
	}
	
	boolean isNterm(Protein prot, int residueNumber) {
		if (prot.residue(residueNumber-1) == null) // End of the chain
			return true;
		return prot.residue(residueNumber - 1).ca() == null;
	}
	
	
	abstract boolean cutN(String seq, int residueNumber);
	abstract boolean cutC(String seq, int residueNumber);
}
